import { AfterViewInit, Component, OnInit, ViewChild  } from '@angular/core';
import { IgxDialogComponent, IgxGridComponent } from "igniteui-angular";
import { DATA, LOCATIONS } from "./data";
import { Product } from "./product";

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit, AfterViewInit {
  @ViewChild("grid1", { read: IgxGridComponent, static: false })
  public grid1: IgxGridComponent;
  @ViewChild("dialogAdd", { read: IgxDialogComponent, static: false })
  public dialog: IgxDialogComponent;
  public data;
  public locations;
  public product;
  public customOverlaySettings;

  public ngOnInit() {
    console.log(this.grid1);
    this.data = DATA.map((e) => {
      const index = Math.floor(Math.random() * LOCATIONS.length);
      const count = Math.floor(Math.random() * 3) + 1;
      e.Locations = [...LOCATIONS].splice(index, count);
      return e;
    });
    this.product = new Product();
    this.locations = LOCATIONS;
  }

  public ngAfterViewInit() {
    this.customOverlaySettings = {
      outlet: this.grid1.outletDirective
    };
  }

  public removeRow(rowIndex) {
    const row = this.grid1.getRowByIndex(rowIndex);
    row.delete();
  }

  public addRow() {
    this.grid1.addRow(this.product);
    this.grid1.addRow(this.product);
    this.cancel();
  }

  private counter = 1;
  // The below method is used to validate the row and is removing 1 of the added row
  validateProduct() {
    //const rows1 = this.grid1.rowList['_results'];
    //let unitStock = 0;
    //if (rows1 && rows1.length > 0) {
    //  for (const x of rows1) {
    //    this.product.push(x['_rowData']);
    //    unitStock = unitStock + x['_rowData']['UnitsInStock'];
    //  }
    //  // create copy of orignal data and use for visualization only
    //  const y = new Set(this.product);
    //  this.product = [...y];
    //} else {
    //  this.product = [];
    //}
    this.data.push({
      ProductID: this.counter,
      ProductName: "Added" + this.counter
    });
    this.counter++;
  }

  public cancel() {
    this.dialog.close();
    this.product = new Product();
  }

  editDone(e: any) {
    //setTimeout(() => {
    if (e.newValue !== e.oldValue) {
      this.validateProduct();
    }
    //}, 500);
  }

  public parseArray(arr: { shop: string, lastInventory: string }[]): string {
    return (arr || []).map((e) => e.shop).join(", ");
  }
}
